#ifndef FEATURE_ICP_ALIGN_H_
#define FEATURE_ICP_ALIGN_H_

//Wolf includes
#include "core/feature/feature_base.h"
#include "core/factor/factor_odom_2D.h"
#include "laser_scan_utils/icp.h"


//std includes

namespace wolf {

WOLF_PTR_TYPEDEFS(FeatureICPAlign);

//class FeatureOdom2D
class FeatureICPAlign : public FeatureBase
{
    public:

        /** \brief Constructor from capture pointer and measure
         *
         * \param _measurement the measurement
         * \param _meas_covariance the noise of the measurement
         *
         */
        FeatureICPAlign(const laserscanutils::icpOutput& _icp_align_res);

        virtual ~FeatureICPAlign();

        /** \brief Generic interface to find factors
         *
         * TBD
         * Generic interface to find factors between this feature and a map (static/slam) or a previous feature
         *
         **/
        virtual void findFactors();

        /** \brief Constructor from capture pointer and measure
         *
         * \param _measurement the measurement
         * \param _meas_covariance the noise of the measurement
         *
         */
        const laserscanutils::icpOutput& getQualityAlign() const;

    private:
        laserscanutils::icpOutput icp_align_res_;

};

} // namespace wolf

#endif
