/**************************
 *      WOLF includes     *
 **************************/
#include <core/processor/processor_base.h>
#include <laser/capture/capture_laser_2D.h>

/**************************
 *      STD includes      *
 **************************/
#include <iostream>
#include <iomanip>
#include <queue>

namespace wolf
{
WOLF_PTR_TYPEDEFS(ProcessorCloseLoopICP);
WOLF_STRUCT_PTR_TYPEDEFS(ProcessorParamsCloseLoopICP);


struct ProcessorParamsCloseLoopICP : public ProcessorParamsBase
{
    int match_past_key_frame;
    ProcessorParamsCloseLoopICP() = default;
    ProcessorParamsCloseLoopICP(std::string _unique_name, const ParamsServer& _server):
        ProcessorParamsBase(_unique_name, _server)
    {
        match_past_key_frame = _server.getParam<int>(_unique_name + "/match_past_key_frame");
    }
    std::string print()
    {
        return "\n" + ProcessorParamsBase::print()
            + "match_past_key_frame: " + std::to_string(match_past_key_frame) + "\n";
    }
};

class ProcessorCloseLoopICP : public ProcessorBase
{
    protected:
    CaptureLaser2DPtr _origin_cpt;
    int count = 0;
    public:
        ProcessorCloseLoopICP(ProcessorParamsBasePtr _params);

        virtual void configure(SensorBasePtr _sensor) override;

        virtual void process(CaptureBasePtr _capture_ptr) override;

        virtual bool voteForKeyFrame() override;

        static ProcessorBasePtr createAutoConf(const std::string& _unique_name, const ParamsServer& _server, const SensorBasePtr sensor_ptr);

        static ProcessorBasePtr create(const std::string& _unique_name, const ProcessorParamsBasePtr _params, const SensorBasePtr);

};

}
