#include "laser/processor/processor_closeloop_icp.h"
#include "laser_scan_utils/icp.h"

using namespace wolf;

// Constructor
ProcessorCloseLoopICP::ProcessorCloseLoopICP(ProcessorParamsBasePtr _params) :
                        ProcessorBase("CL ICP", _params)
{

}

void ProcessorCloseLoopICP::configure(SensorBasePtr _sensor)
{

}

void ProcessorCloseLoopICP::process(CaptureBasePtr _capture_ptr)
{
    // std::cout << "Am I being called?" << std::endl;
    // ++count;
    // CaptureLaser2DPtr cpt_ptr = std::static_pointer_cast<CaptureLaser2D>(_capture_ptr);
    // SensorLaser2DPtr laser_sen = std::static_pointer_cast<SensorLaser2D>(_capture_ptr->getSensor());
    // if(_origin_cpt == nullptr) _origin_cpt = cpt_ptr;
    // if(count % 10 != 0) return;
    // laserscanutils::LaserScanParams scan_params = laser_sen->getScanParams();
    // laserscanutils::LaserScan& last_scan = cpt_ptr->getScan();
    // laserscanutils::LaserScan& origin_scan = _origin_cpt->getScan();
    // std::cout << "Number of ranges: " << cpt_ptr->getScan().ranges_raw_.size() << '\n';
    // Eigen::Vector3s transform_0;
    // transform_0 << 0,0,0;
    // laserscanutils::icp_output result = laserscanutils::ICP::matchPC(last_scan, origin_scan, scan_params, transform_0);
    // std::cout << "We made it past result " << std::endl;
    // std::cout << "My solution " << result.res_transf(0) << "," << result.res_transf(1) << "," << result.res_transf(2) << std::endl;
    // _origin_cpt = cpt_ptr;
}

bool ProcessorCloseLoopICP::voteForKeyFrame()
{
    return 0;
}

ProcessorBasePtr ProcessorCloseLoopICP::create(const std::string& _unique_name, const ProcessorParamsBasePtr _params, const SensorBasePtr)
{
    ProcessorCloseLoopICPPtr prc_ptr;

    ProcessorParamsCloseLoopICPPtr params;
    if (_params)
        params = std::static_pointer_cast<ProcessorParamsCloseLoopICP>(_params);
    else
        params = std::make_shared<ProcessorParamsCloseLoopICP>();

    prc_ptr = std::make_shared<ProcessorCloseLoopICP>(params);
    prc_ptr->setName(_unique_name);

    return prc_ptr;
}

ProcessorBasePtr ProcessorCloseLoopICP::createAutoConf(const std::string& _unique_name, const ParamsServer& _server, const SensorBasePtr sensor_ptr)
{
    ProcessorCloseLoopICPPtr prc_ptr;
    auto params = std::make_shared<ProcessorParamsCloseLoopICP>();
    params->match_past_key_frame = _server.getParam<double>(_unique_name + "/match_past_key_frame", "5");

    prc_ptr = std::make_shared<ProcessorCloseLoopICP>(params);
    prc_ptr->setName(_unique_name);

    return prc_ptr;
}


// Register in the SensorFactory
#include "core/processor/processor_factory.h"
namespace wolf {
WOLF_REGISTER_PROCESSOR("CL ICP", ProcessorCloseLoopICP)
} /* namespace wolf */
#include "core/processor/autoconf_processor_factory.h"
namespace wolf {
    WOLF_REGISTER_PROCESSOR_AUTO("CL ICP", ProcessorCloseLoopICP)
} // namespace wolf
